Index: pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/account.cpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/account.cpp	(revision 4691)
+++ pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/account.cpp	(revision 4692)
@@ -301,7 +301,6 @@
 
 /* Convert to pjsip. */
-pjsua_acc_config AccountConfig::toPj() const
-{
-    pjsua_acc_config ret;
+void AccountConfig::toPj(pjsua_acc_config &ret) const
+{
     unsigned i;
 
@@ -425,6 +424,4 @@
     ret.vid_stream_rc_cfg.method= videoConfig.rateControlMethod;
     ret.vid_stream_rc_cfg.bandwidth = videoConfig.rateControlBandwidth;
-
-    return ret;
 }
 
@@ -670,6 +667,7 @@
                      bool make_default) throw(Error)
 {
-    pjsua_acc_config pj_acc_cfg = acc_cfg.toPj();
-
+    pjsua_acc_config pj_acc_cfg;
+    
+    acc_cfg.toPj(pj_acc_cfg);
     pj_acc_cfg.user_data = (void*)this;
     PJSUA2_CHECK_EXPR( pjsua_acc_add(&pj_acc_cfg, make_default, &id) );
@@ -678,5 +676,7 @@
 void Account::modify(const AccountConfig &acc_cfg) throw(Error)
 {
-    pjsua_acc_config pj_acc_cfg = acc_cfg.toPj();
+    pjsua_acc_config pj_acc_cfg;
+    
+    acc_cfg.toPj(pj_acc_cfg);
     pj_acc_cfg.user_data = (void*)this;
     PJSUA2_CHECK_EXPR( pjsua_acc_modify(id, &pj_acc_cfg) );
Index: pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/endpoint.cpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/endpoint.cpp	(revision 4691)
+++ pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/endpoint.cpp	(revision 4692)
@@ -384,4 +384,13 @@
     }
 
+    delete writer;
+    
+    while(mediaList.size() > 0) {
+	AudioMedia *cur_media = mediaList[0];
+	delete cur_media; /* this will remove itself from the list */
+    }
+
+    clearCodecInfoList();
+
     try {
 	libDestroy();
@@ -390,12 +399,4 @@
 	PJ_UNUSED_ARG(err);
     }
-    delete writer;
-    
-    while(mediaList.size() > 0) {
-	AudioMedia *cur_media = mediaList[0];
-	delete cur_media; /* this will remove itself from the list */
-    }
-
-    clearCodecInfoList();
 
     instance_ = NULL;
@@ -1567,7 +1568,6 @@
     PJSUA2_CHECK_EXPR( pjsua_enum_codecs(pj_codec, &count) );
 
+    pj_enter_critical_section();
     clearCodecInfoList();
-
-    pj_enter_critical_section();
     for (unsigned i=0;(i<count && i<MAX_CODEC_NUM);++i) {
 	CodecInfo *codec_info = new CodecInfo;
@@ -1608,9 +1608,7 @@
 void Endpoint::clearCodecInfoList()
 {
-    pj_enter_critical_section();
     for (unsigned i=0;i<codecInfoList.size();++i) {
 	delete codecInfoList[i];
     }
     codecInfoList.clear();
-    pj_leave_critical_section();
-}
+}
Index: pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/media.cpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/media.cpp	(revision 4691)
+++ pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/media.cpp	(revision 4692)
@@ -454,7 +454,6 @@
     PJSUA2_CHECK_EXPR( pjsua_enum_aud_devs(pj_info, &count) );
 
+    pj_enter_critical_section();
     clearAudioDevList();
-
-    pj_enter_critical_section();
     for (unsigned i = 0; (i<count && i<MAX_DEV_COUNT) ;++i) {
 	AudioDevInfo *dev_info = new AudioDevInfo;
@@ -748,10 +747,8 @@
 void AudDevManager::clearAudioDevList()
 {
-    pj_enter_critical_section();
     for(unsigned i=0;i<audioDevList.size();++i) {
 	delete audioDevList[i];
     }
     audioDevList.clear();
-    pj_leave_critical_section();
 }
 
Index: pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/siptypes.cpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/siptypes.cpp	(revision 4691)
+++ pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/siptypes.cpp	(revision 4692)
@@ -167,5 +167,6 @@
     // The following will only work if sizeof(enum)==sizeof(int)
     pj_assert(sizeof(ts.ciphers[0]) == sizeof(int));
-    ts.ciphers		= (pj_ssl_cipher*)&this->ciphers[0];
+    ts.ciphers		= ts.ciphers_num? 
+			    (pj_ssl_cipher*)&this->ciphers[0] : NULL;
     ts.verify_server	= this->verifyServer;
     ts.verify_client	= this->verifyClient;
Index: pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/util.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/util.hpp	(revision 4691)
+++ pjproject/branches/projects/pjsua2/pjsip/src/pjsua2/util.hpp	(revision 4692)
@@ -37,5 +37,7 @@
 inline string pj2Str(const pj_str_t &input_str)
 {
-    return string(input_str.ptr, input_str.slen);
+    if (input_str.ptr)
+	return string(input_str.ptr, input_str.slen);
+    return string();
 }
 
